BIN_2_BCD
 bcf		INTCON,GIEH,ACCESS		;   
	movff24	TOSL,CallAdrBuf	;   
	pop	;    ,     ()
 bsf		INTCON,GIEH,ACCESS		;   	
	bsf	LCD_Flg1,2,0 ;2=  BIN_2_BCD = 1

;********************************************************************
;                Binary To BCD Conversion Routine (16 Bit)
;                       (Partial Straight Line Version)
;      This routine converts a 16 Bit binary Number to a 5 Digit
; BCD Number.
;       The 16 bit binary number is input in locations Hbyte and
; Lbyte with the high byte in Hbyte.
;       The 5 digit BCD number is returned in R0, R1 and R2 with R0
; containing the MSD in its right most nibble.
;   Performance :
;               Program Memory  :  44
;               Clock Cycles    :  572
;*******************************************************************;
;	setf     Hbyte, F
;	setf     Lbyte, F
;                              ; 16 bit binary num = 0xffff
;	call    B2_BCD_Looped   ; after conversion the Decimal Num
;                               ; in R0, R1, R2 = 06,55,35
;	setf     Hbyte, F
;	setf     Lbyte, F
;	call    B2_BCD_Straight ; same as above, but straight line code

BIN_2_BCD_First

;      
;     17  18 ,
;       /.
; 16 bit binary num = 0xffff   Format_Buf
;     Tmp+1,Tmp+2, Tmp+3 
;          .
;  ,  8/16      0   .
;    - 10   572  = 17.5   .
;    ?   21        PCPWM.
;      .
;   16 -     
 
	bcf      _C			;ALUSTA,C
	movlf	d'15',Tmp_0+5,BANKED;  16 (15+1) .
	movlf	d'1',Tmp_0,BANKED	;  1   .
;	clrf     Tmp_0,BANKED		;   2  -  .
;	bsf      Tmp_0,4,BANKED    ; set count = 16
	clrf     Tmp_0+1,BANKED		;R2
	clrf     Tmp_0+2,BANKED		;R1
	clrf     Tmp_0+3,BANKED		;R0

loop16b

	rlcf     Format_Buf,F,ACCESS	;   
	rlcf     Format_Buf+1,F,ACCESS	; 16  
	rlcf     Tmp_0+1,F,BANKED		;R2   
	rlcf     Tmp_0+2,F,BANKED		;R1 
	rlcf     Tmp_0+3,F,BANKED		;R0   
;
	dcfsnz   Tmp_0, F,BANKED ;    16  ********
; bra AdjustBCD ;        
;   STATUS   -  
	return ; DONE -    -   

;      adjustBCD    . 
;           DAW.
AdjustBCD
	lfsr	0,Tmp_0		;    -1  FSR0
adjustBCD_R2
	movf    PREINC0,W,ACCESS
	bz		adjustBCD_R1;   =0,  adjustBCD   
	addlw    0x03
	btfsc    WREG,3,ACCESS          ; test if result > 7
	movwf    INDF0,ACCESS
	movf    INDF0,W,ACCESS
	addlw    0x30
	btfsc    WREG,7          ; test if result > 7
	movwf    INDF0,ACCESS        ; save as MSD
adjustBCD_R1
	movf	PREINC0,W,ACCESS
	bz		adjustBCD_R0;   =0,  adjustBCD   
	addlw    0x03
	btfsc    WREG,3,ACCESS          ; test if result > 7
	movwf    INDF0,ACCESS
	movf    INDF0,W,ACCESS
	addlw    0x30
	btfsc    WREG,7,ACCESS          ; test if result > 7
	movwf    INDF0,ACCESS           ; save as MSD
adjustBCD_R0
	movf	PREINC0,W,ACCESS
	bz		loop16b		;   =0,  adjustBCD   
	addlw    0x03
	btfsc    WREG,3,ACCESS          ; test if result > 7
	movwf    INDF0,ACCESS
	movf    INDF0,W,ACCESS
	addlw    0x30
	btfsc    WREG,7,ACCESS          ; test if result > 7
	movwf    INDF0,ACCESS           ; save as MSD
;
	bra    loop16b
;**********************************************************************************************

B_2_D_Resume	;    
	movlf	d'1',Tmp_0,BANKED	;  1   .
	decfsz   Tmp_0+5, F,BANKED
 bra AdjustBCD ;  16  
;   STATUS   -  
;	return ; DONE -    -   
	bcf	LCD_Flg1,2,0 ;2=  BIN_2_BCD = 1
	push	;  
	LCD_BCD_BANK	;
;Error[172] : PCL, TOSL, TOSH, or TOSU cannot be a destination of MOVFF or MOVSF
;	movff24	CallAdrBuf,TOSL ;   
 bcf		INTCON,GIEH,ACCESS		;   
	movf	CallAdrBuf,W,BANKED	;
	movwf	TOSL,ACCESS			;
	movf	CallAdrBuf+1,W,BANKED	;
	movwf	TOSL+1,ACCESS			;
	movf	CallAdrBuf+2,W,BANKED	;
	movwf	TOSL+2,ACCESS			;
 bsf		INTCON,GIEH,ACCESS		;   	
	LCD_BANK	;
;	movlf	d'8',Tmp_0,BANKED	;  8    .
;     
  bra AdjustBCD ;        