;******************************************************************************
;    Filename: Main_Module.Asm                                                *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC                        *
;                                                                             *
;******************************************************************************
;   Proj_Dir    :
	#include Define.h	;     
;;   -      Define	
;******************************************************************************
;
; Configuration bits
    CONFIG	CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF ;   Code Protection Block
	CONFIG	CPB = OFF, CPD = OFF ; Boot Block and Data EEPROM Code Protection
;    CONFIG	OSC = HS,FCMEN=OFF,IESO=OFF        	  ;IRCIO
    CONFIG	FCMEN=ON,IESO=ON; Fail Safe Clock Monitor=On, Internal External Switchover mode enabled

 #ifdef	PORTD	;4431
    CONFIG	OSC = HSPLL	;12->48 MHz
 #else			;2431
    CONFIG	OSC = ECIO	;Ext 48 MHz, Pin10 = Port A6 = I/O
; CONFIG	OSC = IRCIO ;Internal oscillator block, port function on RA6 and port function on RA7

 #endif

;    CONFIG	OSC = IRCIO,FCMEN=OFF,IESO=OFF        ;LP
	CONFIG	PWRTEN=OFF,BOREN=ON,BORV=27	;

;	CONFIG	WDTEN=ON,WINEN=OFF,WDPS=1	;  , ,   4  
 #ifndef	__DEBUG_
	CONFIG	WDTEN=OFF,WINEN=OFF,WDPS=1	;     -  .
 #else
	CONFIG	WDTEN=ON,WINEN=OFF,WDPS=1	;  , ,   4  
 #endif

	 #ifdef	PCPWM_Present
;    -    ???
 #ifdef	PCPWM_IRAMY; Yes;   IRAMY
 	CONFIG	PWMPIN=OFF;   1 
	CONFIG	LPOL=LOW,HPOL=LOW ;HIGH;    -   
;   Independent mode.   IRAMX     .
;      -     .
 #else	; IRAMX
 	CONFIG	PWMPIN=ON;OFF;   PCPWM 
	CONFIG	LPOL=LOW,HPOL=LOW ;HIGH;    -   
;   Independent mode.   IRAMX     .
;      -     .
 #endif

 	#else
 		CONFIG	PWMPIN=OFF;   PCPWM 
 	#endif

;	CONFIG	,GPTREN=ON

 #ifdef	PORTD	;4431
	CONFIG	FLTAMX=RD4
	CONFIG	PWM4MX=RB5
	CONFIG	SSPMX=RD1
	CONFIG	EXCLKMX=RC3
 #endif
;   Stack Full/Underflow Reset Enable bit:
;     STVREN = OFF         Stack full/underflow will not cause Reset
;     STVREN = ON          Stack full/underflow will cause Reset
	CONFIG	STVREN=ON ;

	CONFIG	MCLRE=OFF;   13/01/2020   20
	CONFIG	LVP=OFF,DEBUG=OFF	; RB5 & RB6 & RB7 = general I/O

;******************************************************************************
 #ifdef	EPROM_Present
	#ifndef	NotEpromParamProg
EEPROM_data code_pack 0xf00000 ;   
EPROM_DatB	;    
  #include Proj_Dir\EPROM\EPROM_Data.inc	;    
EPROM_DatE	;    
	#endif	;	#ifndef	NotEpromParamProg
 #endif ; #ifdef	EPROM_Present
;******************************************************************************
	
;	extern	TestCRC,KeyboardRead;

	
;

; *****************     -    
Main_L	code	;	0x250	;     - BRA  
; Start of main program
 global	InitAll	;
InitAll:
	movff	RCON,RCON_Print	; Copy RCON for LCD and analize	
	clrwdt ;  4  - ,  4+ 
; 	bsf	OSCCON,IRCF0,ACCESS	;    RC  8  

;#ifdef __DEBUG
;	bsf Math_Flag,0,ACCESS	;   
;;0= /     MainLoop	
;	bcf	RevCalc_Flag,0,BANKED;    
;	clrf Math_Cmd,ACCESS	;   0 
;	bsf Math_Flag,0,ACCESS	;   
;	;btfsc	PCPWM_Flag,7,ACCESS	;   ?
; bra	MainLoop
;#endif
;#ifdef __DEBUG
;	bsf Math_Flag,0,ACCESS	;   
;;0= /     MainLoop	
;	bcf	RevCalc_Flag,0,BANKED;    
;	clrf Math_Cmd,ACCESS	;   0 
;	bsf Math_Flag,0,ACCESS	;   
;	;btfsc	PCPWM_Flag,7,ACCESS	;   ?
;; bra	MainLoop
;#endif
;
;    RCON       - 
;   1 ( ) 0F ( ) 0E ( ) 07 (WDT TimeOut) .
; ;bra InitAll ;    PCPWM  RESET
	bsf		RCON,IPEN,ACCESS		;   
	bcf		RCON,NOT_RI,ACCESS		; RESET  
	bsf		RCON,NOT_POR,ACCESS		; 
	bsf		RCON,NOT_BOR,ACCESS		; , BOR   

	DefaultBankSelect	;   
 #include Proj_Dir\_Out\Init_All.inc	;      .


 #ifdef	PCPWM_Dbg12b	;  12  
   #ifdef	__DEBUG		;    DeBug
	EXTERN	PDC_TableLoad	;
; call	PDC_TableLoad		;
;	 #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    
;	 #include Proj_Dir\PCPWM_3F\Dbg12b.inc	;  -   
	nop
;	 #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    
;	 #include Proj_Dir\PCPWM_3F\Dbg12b.inc	;   13/01/2019
;	 #include Proj_Dir\PCPWM_3F\Dbg12b_1-4.inc;   12  /
	 #include Proj_Dir\PCPWM_3F\Dbg9b_1-4.inc;   8+1  /

   #endif ;__DEBUG		;    DeBug
 #endif ;PCPWM_Dbg12b	;  12  

MainLoopRestore:
	bsf		INTCON,GIEH,ACCESS		;    	
	bsf		INTCON,GIEL,ACCESS		;    
;	bsf		ADCON0,GO_DONE,ACCESS	;    
#ifndef	__DEBUG
		bsf		WDTCON,SWDTEN,ACCESS	;	 
#endif ;#ifndef	__DEBUG
	clrf	WDT_Counter,ACCESS	;   
	clrf	WDT_Flag,ACCESS	;   
		bra WDT_Init;    
MainLoop:
; #ifdef __DEBUG
;	 bra TestLoop
; endif ;; #ifdef __DEBUG
;		clrwdt ;  4  - ,  4+ 

	dcfsnz	WDT_Counter,F,ACCESS;    MainLoop
		bcf	WDT_Flag,2,ACCESS	;    MainLoop
 	;incfsz	WDT_Counter,F,ACCESS;    256 - 
	btfsc	WDT_Flag,0,ACCESS	;      ADC 
		bra	Done_WDT
	movf	WDT_Flag,W,ACCESS	;        ?
		bnz	Done_WDT
WDT_Init:
	movlf	d'30',WDT_ADC,ACCESS;     ADC  18 750/250 
;	movlf	d'46',WDT_PWM,ACCESS;    PWM  11 718.75/250 
	movlf	d'2',WDT_Counter,ACCESS;   Main_Loop  
	bsf	WDT_Flag,0,ACCESS	;    ADC
	;bsf	WDT_Flag,1,ACCESS	;    PWM
	bsf	WDT_Flag,2,ACCESS	;    Main_Loop
		clrwdt ;  4  - ,  4+ 
Done_WDT:
;
	DefaultBankSelect	;   		
; The main program LOOP code is placed here.
 #include Proj_Dir\_Out\MLTask_All.inc	;     .
; 
 goto MainLoop
 

;       -    ?
 Global CaseGoTo
CaseGoTo:	;;  - WREG
; K8LH RE: PIC18F4331: COMPUTED GOTO! Thursday, August 17, 2006 8:22 AM (permalink)
;http://www.microchip.com/forums/m182713.aspx javascript:void(showMsgNum(182838))
	bcf	_C	;       
		rlncf   WREG,F,ACCESS   ;  
 Global CaseBra
CaseBra:	;   -  
		rlncf   WREG,F,ACCESS   ;
	bcf	WREG,0,ACCESS	;      
	addwf   TOSL,f,ACCESS ;  
	movlw   0x0           ; 
	addwfc  TOSH,f,ACCESS ; 
;addwfc  TOSU,f,ACCESS;  for > 64-kbyte memory
	return;       WREG

 #ifdef	RestoreMainLoop
 Global Restore_ML
Restore_ML	;        
;    -      
	bcf		INTCON,GIEH,ACCESS		;    disable
;	bcf		INTCON,GIEL,ACCESS		;    disable
	movff	WREG, WREG_Restore	;  
	movff	TOSL, TOSL_Restore	; 
	movff	TOSH, TOSH_Restore	; 
	movff	TOSU, TOSU_Restore	; 
		clrf	STKPTR,ACCESS	; 
	Beeper	d'127';  
 DefaultBankSelect	;   
	decfsz	Restore_Counter,F,BANKED;      ?	
		goto	MainLoopRestore
	reset	;  
 #endif ; #ifdef	RestoreMainLoop

 #ifdef	LCD_Present
	global	LCD_Len	;
LCD_Len	;    
	retlw	(MsgS-MsgI)/2	;   ,    . 
 #endif

 #ifdef	PCPWM_Present
	global	PCPWM_Frq_Len	;
PCPWM_Frq_Len	;
	retlw	(TabDeltAngle-TabPwmFreq)/FrqLen	;   
 #endif

 #ifdef	DelayCuriosityTest	; 07/03/2020   
	global	DelayCuriosity	;   
DelayCuriosity	;      ,
;  1    ,   8+4*index
	movf	DelayCuriosityIndex,W,ACCESS
DelayLoop;
	nop	;
	decfsz	WREG,W,ACCESS
		bra	DelayLoop;
	return	;
 #endif ;#ifdef	DelayCuriosityTest	; 07/03/2020   


;      Bra -           NOP.
#ifndef __DEBUG_;*******  
Data_Table_All	code_pack 	;0x3230	;         
#else 	;#ifndef __DEBUG_;
Data_Table_All	code_pack	0x235E	;         
#endif	;#ifndef __DEBUG_;

 #ifdef	RestoreMainLoop
;       - 
	movlw	0x13	;    
 call	Restore_ML	; 0x13        
 #endif ; #ifdef	RestoreMainLoop

; The main program LOOP code is placed here.
 #include Proj_Dir\_Out\Table_All.inc	;      .

; #ifdef	EPROM_Present	
; #endif ;#ifdef	EPROM_Present	;       /

 #ifdef	EPROM_Present	;;       /
	#ifndef	NotEpromParamProg

 #if ((EPROM_Table_End-EPROM_Table)/2) != (ParametrCmn+ParamBlockLen) ;   
  error "Size defined RAM Block NOT equal summ of ParametrCmn + ParamBlockLen" 
 #endif ;#if ((EPROM_Table_End-EPROM_Table)/2) != (ParametrCmn+ParamBlockLen) ;   
 
 #if (EPROM_DatE-EPROM_DatB) != (ParametrCmn+ParamBlockLen*ParamBlockNum) ;    
  messg "Size defined EPROM Block NOT equal summ of ParametrCmn + ParamBlockLen*ParamBlockNum" 
 #endif ;#if (EPROM_DatE-EPROM_DatB) != (ParametrCmn+ParamBlockLen*ParamBlockNum) ;    

	#endif	;	#ifndef	NotEpromParamProg
 #endif ; #ifdef	EPROM_Present

;End of program
		END
